#-----------------------------------------------------------------------

browseURL(paste0("http://bcs.wiley.com/he-bcs/Books?action=",
                 "chapter&bcsId=7327&itemId=1118146816&chapterId=80371"))
# arquivo: ch09.xlxs, sheet: Table9-2, coluna: B.

x <- c(9.45, 7.99, 9.29, 11.66, 12.16, 10.18, 8.04, 11.46, 9.20, 10.34,
       9.03, 11.47, 10.51, 9.40, 10.08, 9.37, 10.62, 10.31, 8.52, 10.84,
       10.90, 9.33, 12.29, 11.50, 10.60, 11.08, 10.38, 11.62, 11.31,
       10.52)
i <- seq_along(x)

library(qcc)

qcc(x[1:20], type = "xbar.one", newdata = x[21:30])

#-----------------------------------------------------------------------

mu0 <- 10  # Valor alvo do processo.
sigma <- 1 # Desvio-padrão do processo.
delta <- 1 # Diferença na média a ser detectada.
K <- 1/2

xd <- c(0, x)
Cp <- numeric(length(xd))
Cm <- numeric(length(xd))

for (i in 2:length(xd)) {
    if (xd[i] - mu0 > 0) {
        Cp[i] <- max(c(0, xd[i] - (mu0 + K) + Cp[i - 1]))
    } else {
        Cm[i] <- max(c(0, (mu0 - K) - xd[i] + Cm[i - 1]))
    }
}

Cpm <- cbind(Cp, -Cm)
i <- 1:nrow(Cpm) - 1

matplot(x = i, y = Cpm, type = "o", pch = 1, lty = 1)
abline(h = mu0 + c(-5, 5) * sigma, lty = 2, col = 3)

#-----------------------------------------------------------------------
# Usando o qcc.

qcc(x[1:20], type = "cumsum", newdata = x[21:30])

help(cusum, h = "html")

cusum(x[1:20],
      decision.interval = 5,
      se.shift = K * sigma,
      newdata = x[21:30])
sd(x[1:20])

cusum(x[1:20],
      decision.interval = 5/sd(x[1:20]),
      se.shift = K * sigma,
      newdata = x[21:30])

#-----------------------------------------------------------------------
